
-- On server machine 
-- MD C:\DATA
-- MD C:\Backups
-- del C:\Backups\justdave.bak

-- Drop database justdave1

CREATE DATABASE justdave1;

DROP TABLE IF EXISTS dbo.Numbers1;

CREATE TABLE dbo.Numbers1 (
  NumberID int NOT NULL 
 );
 
CREATE CLUSTERED INDEX ix_NumberID1 ON dbo.Numbers1(NumberID);
  
WITH
  Pass0 as (select 1 as C union all select 1), --2 rows
  Pass1 as (select 1 as C from Pass0 as A, Pass0 as B),--4 rows
  Pass2 as (select 1 as C from Pass1 as A, Pass1 as B),--16 rows
  Pass3 as (select 1 as C from Pass2 as A, Pass2 as B),--256 rows
  Pass4 as (select 1 as C from Pass3 as A, Pass3 as B),--65536 rows
  Pass5 as (select 1 as C from Pass4 as A, Pass4 as B),--4,294,967,296 rows
  Tally as (select row_number() over(order by C) as Number from Pass5)
INSERT dbo.Numbers1 (NumberID)
 select TOP(1000) Number
  from Tally;

UPDATE STATISTICS dbo.Numbers1 WITH FULLSCAN;

-- Enable actual plan

SELECT *
FROM dbo.Numbers1
WHERE NumberID = 1;

SELECT a.NumberID FROM dbo.Numbers1 AS a
JOIN dbo.Numbers1 AS b
ON a.NumberID = b.NumberID
WHERE a.NumberID = 1;


